From 0d0c309de1ad22a31043e61dc84444131a610adb Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 07 2015 14:47:08 +0000
Subject: [PATCH 141/1001] Start using the new associations model stuff in some widgets to test it out.


---

diff --git a/hubs/models.py b/hubs/models.py
index 40fbb0b..8c7a51a 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -116,18 +116,26 @@ class Hub(BASE):
 
     #fas_group = sa.Column(sa.String(32), nullable=False)
 
-    # This is just some silly dev data.  eventually, connect this
-    # to real database data.
-    owners = ['tatica', 'gnokii', 'duffy', 'ryanlerch']
-    members = ['ralph', 'sadin', 'sayan'] + owners
-    subscribers = []
+    @property
+    def owners(self):
+        return [assoc.user for assoc in self.associations
+                if assoc.role == 'owner']
+    @property
+    def members(self):
+        return [assoc.user for assoc in self.associations
+                if assoc.role == 'member' or assoc.role =='owner']
 
+    @property
+    def subscribers(self):
+        return [assoc.user for assoc in self.associations
+                if assoc.role == 'subscriber']
 
-    def subscribe(self, session, user):
+    def subscribe(self, session, user, role='subscriber'):
+        """ Subscribe a user to this hub. """
         # TODO -- add logic here to manage not adding the user multiple
         # times, doing different roles, etc.. publish a fedmsg message,
         # etc...
-        session.add(Association(user=user, hub=self, role='subscriber'))
+        session.add(Association(user=user, hub=self, role=role))
         session.commit()
 
     @classmethod
@@ -231,15 +239,12 @@ class User(BASE):
     fullname = sa.Column(sa.Text)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
 
-    @property
-    def avatar(self):
-        return username2avatar(self.username)
 
     def __json__(self, session):
         return {
             'username': self.username,
             'openid': self.openid,
-            'avatar': self.avatar,
+            'avatar': username2avatar(self.username),
             'fullname': self.fullname,
             'created_on': self.created_on,
             # We'll need hubs subscribed to, owned, etc..
@@ -272,9 +277,5 @@ class User(BASE):
             if not Hub.by_name(session, self.username):
                 Hub.create_user_hub(session, self.username, self.fullname)
 
-            # Subscribe self to some default hubs for now..
-            hub = Hub.by_name(session, 'designteam')
-            hub.subscribe(session, self)
-
             session.commit()
         return self
diff --git a/hubs/widgets/rules.py b/hubs/widgets/rules.py
index ae36938..3a1dd16 100644
--- a/hubs/widgets/rules.py
+++ b/hubs/widgets/rules.py
@@ -42,7 +42,7 @@ template = jinja2.Template("""
           help="Link to the community rules and guidelines")
 def data(session, widget, link):
     owners = widget.hub.owners
-    owners = ordereddict([(o, avatar(o)) for o in owners])
+    owners = ordereddict([(o.username, avatar(o.username)) for o in owners])
     return dict(owners=owners, link=link)
 
 
diff --git a/hubs/widgets/stats.py b/hubs/widgets/stats.py
index 1826c62..67a0e26 100644
--- a/hubs/widgets/stats.py
+++ b/hubs/widgets/stats.py
@@ -8,17 +8,28 @@ template = jinja2.Template("""
 <div class="stats-container">
   <table class="stats-table">
     <tr><th>Members</th><th>Subscribers</th></tr>
-    <tr class="text-info"><td>{{members}}</td><td>{{subscribers}}</td></tr>
+    <tr class="text-info"><td>{{members | length}}</td><td>{{subscribers | length}}</td></tr>
   </table>
-  <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+  {% if g.auth.logged_in %}
+    {% if g.auth.nickname in members %}
+    <div class="pull-right"><button class="btn btn-danger">Resign</button></div>
+    {% elif g.auth.nickname in subscribers %}
+    <div class="pull-right"><button class="btn btn-warning">Unsubscribe</button></div>
+    {% else %}
+    <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+    {% endif %}
+  {% else %}
+    <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+  {% endif %}
 </div>
 """)
 
 
 def data(session, widget):
     return dict(
-        members=len(widget.hub.members),
-        subscribers=len(widget.hub.subscribers),
+        owners=[u.username for u in widget.hub.owners],
+        members=[u.username for u in widget.hub.members],
+        subscribers=[u.username for u in widget.hub.subscribers],
     )
 
 
diff --git a/populate.py b/populate.py
index d8efe61..3c517f4 100755
--- a/populate.py
+++ b/populate.py
@@ -10,6 +10,18 @@ fedmsg_config = fedmsg.config.load_config()
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
+users = ['mrichard', 'duffy', 'ryanlerch', 'gnokii', 'nask0',
+         'abompard', 'decause', 'ralph']
+for username in users:
+    fullname = 'Full Name Goes Here'
+    openid = '%s.id.fedoraproject.org' % username
+    print "Creating account for %r" % openid
+    hubs.models.User.get_or_create(
+        session, openid=openid, fullname=fullname)
+
+session.commit()
+
+
 ############## Infra team
 hub = hubs.models.Hub(name='designteam', summary='The Fedora Design Team')
 session.add(hub)
@@ -41,6 +53,16 @@ widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
 hub.widgets.append(widget)
 
 
+# Set up some memberships
+hub.subscribe(session, hubs.models.User.by_openid(session, 'duffy.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'ryanlerch.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'gnokii.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'mrichard.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'nask0.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'decause.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'ralph.id.fedoraproject.org'), 'subscriber')
+
+
 ############## Infra team
 hub = hubs.models.Hub(name='infrastructure', summary='The Fedora Infrastructure Team')
 session.add(hub)
@@ -71,4 +93,10 @@ hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
 hub.widgets.append(widget)
 
+
+hub.subscribe(session, hubs.models.User.by_openid(session, 'ralph.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'abompard.id.fedoraproject.org'), 'owner')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'nask0.id.fedoraproject.org'), 'member')
+hub.subscribe(session, hubs.models.User.by_openid(session, 'decause.id.fedoraproject.org'), 'subscriber')
+
 session.commit()

